package sign;
import cn.tsign.hz.comm.EsignHttpHelper;
import cn.tsign.hz.comm.EsignHttpResponse;
import cn.tsign.hz.enums.EsignRequestType;
import cn.tsign.hz.exception.EsignDemoException;
import com.google.gson.Gson;
import java.util.Map;
/*流程模板API*/
public class SignDemo {
    /*
    eSignHost 域名信息:
    正式环境域名：https://openapi.esign.cn
    沙箱环境域名：https://smlopenapi.esign.cn
     */
    private static String eSignHost= "";
      /*
    eSignAppId和eSignAppSecret为接口秘钥信息，
    获取方式教程：https://open.esign.cn/doc/opendoc/dev-guide3/qwnnsb
     */

    private static String eSignAppId="";
    private static String eSignAppSecret="";
    //signTemplateId为模板ID，通过官网获取
    private static String signTemplateId="";
    //orgid 平台方企业orgId获取教程 https://open.esign.cn/doc/opendoc/helper/wcs358yp0g1uwoq9
    private static String orgid="";

    public static void main(String[] args) throws EsignDemoException {
        Gson gson = new Gson();

//        /* 查询流程模板详情*/
//        EsignHttpResponse result = SignTemplatesDetail();
//        JsonObject resultJsonObject = gson.fromJson(result.getBody(), JsonObject.class).getAsJsonObject("data");
//        System.out.println("响应结果:"+resultJsonObject);
//        /* 创建合同拟定和签署流程*/
//        EsignHttpResponse result2 = CreateBySignTemplate();
//        JsonObject resultJsonObject2 = gson.fromJson(result2.getBody(), JsonObject.class).getAsJsonObject("data");
//        System.out.println("响应结果:"+resultJsonObject2);
//        /* （可选）获取填写页面链接*/
//        EsignHttpResponse result3 = DraftUrl();
//        JsonObject resultJsonObject3 = gson.fromJson(result3.getBody(), JsonObject.class).getAsJsonObject("data");
//        System.out.println("响应结果:"+resultJsonObject3);
//        /* （可选）获取签署页面链接*/
//        EsignHttpResponse result4 = signUrl();
//        JsonObject resultJsonObject4 = gson.fromJson(result4.getBody(), JsonObject.class).getAsJsonObject("data");
//        System.out.println("响应结果:"+resultJsonObject4);
//        /* （可选）下载已签署文件及附属材料*/
//        EsignHttpResponse result5 = SignTemplatesDetail();
//        JsonObject resultJsonObject5 = gson.fromJson(result5.getBody(), JsonObject.class).getAsJsonObject("data");
//        System.out.println("响应结果:"+resultJsonObject5);


    }
    /**
     * 查询流程模板详情
     * @return
     */
    public static EsignHttpResponse SignTemplatesDetail( ) throws EsignDemoException {
        String apiaddr= "/v3/sign-templates/detail?orgId="+orgid+"&queryComponents=true&signTemplateId="+signTemplateId;
        //请求参数body体,json格式。get或者delete请求时jsonString传空json:"{}"或者null
        String jsonParm = null;
        //请求方法
        EsignRequestType requestType = EsignRequestType.GET;
        //生成签名鉴权方式的的header
        Map<String, String> header = EsignHttpHelper.signAndBuildSignAndJsonHeader(eSignAppId,eSignAppSecret,jsonParm,requestType.name(),apiaddr,true);
        //发起接口请求
        return EsignHttpHelper.doCommHttp(eSignHost, apiaddr,requestType , jsonParm, header,false);
    }

    /**
     * 创建合同拟定和签署流程
     * （双方签署为例，个人签署和企业签署）
     * @return
     */
    public static EsignHttpResponse CreateBySignTemplate() throws EsignDemoException {

        String apiaddr= "/v3/sign-flow/create-by-sign-template";
        //请求参数body体,json格式。get或者delete请求时jsonString传空json:"{}"或者null
        String jsonParm = "{\n" +
                "    \"signTemplateId\": \""+signTemplateId+"\",\n" +
                "    \"signFlowConfig\": {\n" +
                "        \"signFlowTitle\": \"这是本次签署任务的主题\",\n" +
                "        \"autoFinish\": true,\n" +
                "        \"signConfig\": {\n" +
                "            \"availableSignClientTypes\": 1,\n" +
                "            \"autoFillAndSubmit\": true\n" +
                "        },\n" +
                "        \"noticeConfig\": {\n" +
                "            \"noticeTypes\": \"1\"\n" +
                "        },\n" +
                "        \"notifyUrl\": \"http://xx.xx.xx.xx:8081/notify\"\n" +
                "    },\n" +
                "    \"participants\": [\n" +
                "        {\n" +
                "            \"participantId\": \"需要用【查询流程模板详情】接口查询参与方ID\",\n" +
                "            \"psnParticipant\": {\n" +
                "                \"psnAccount\": \"参与方手机号\",\n" +
                "                \"psnName\": \"参与方姓名\"\n" +
                "            }\n" +
                "        },\n" +
                "        {\n" +
                "            \"participantId\": \"需要用【查询流程模板详情】接口查询参与方ID\",\n" +
                "            \"orgParticipant\": {\n" +
                "                \"orgName\": \"参与方企业名称\",\n" +
                "                \"transactor\": {\n" +
                "                    \"transactorPsnAccount\": \"参与方手机号\",\n" +
                "                    \"transactorName\": \"参与方姓名\"\n" +
                "                }\n" +
                "            }\n" +
                "        }\n" +
                "    ],\n" +
                "    \"components\": [\n" +
                "        {\n" +
                "            \"fileId\": \"需要用【查询流程模板详情】接口查询文件ID\",\n" +
                "            \"componentKey\": \"自定义控件编码\",\n" +
                "            \"componentValue\": \"填充值\"\n" +
                "        }\n" +
                "    ]\n" +
                "}";
        //请求方法
        EsignRequestType requestType = EsignRequestType.POST;
        //生成签名鉴权方式的的header
        Map<String, String> header = EsignHttpHelper.signAndBuildSignAndJsonHeader(eSignAppId,eSignAppSecret,jsonParm,requestType.name(),apiaddr,true);
        //发起接口请求
        return EsignHttpHelper.doCommHttp(eSignHost, apiaddr,requestType , jsonParm, header,true);
    }


    /**
     * （可选）获取填写页面链接
     * @return
     */
    public static EsignHttpResponse DraftUrl( ) throws EsignDemoException {
        //signFlowId签署流程ID
        String signFlowId="";
        String apiaddr= "/v3/sign-flow/"+signFlowId+"/draft-url";
        //请求参数body体,json格式。get或者delete请求时jsonString传空json:"{}"或者null
        String jsonParm = "{\n" +
                "    \"operator\": {\n" +
                "        \"psnAccount\": \"填写人的手机号\"\n" +
                "    },\n" +
                "    \"needLogin\":false,\n" +
                "    \"redirectConfig\": {\n" +
                "        \"redirectUrl\": \"重定向跳转地址\"\n" +
                "    }\n" +
                "}";
        //请求方法
        EsignRequestType requestType = EsignRequestType.POST;
        //生成签名鉴权方式的的header
        Map<String, String> header = EsignHttpHelper.signAndBuildSignAndJsonHeader(eSignAppId,eSignAppSecret,jsonParm,requestType.name(),apiaddr,true);
        //发起接口请求
        return EsignHttpHelper.doCommHttp(eSignHost, apiaddr,requestType , jsonParm, header,false);
    }

    /**
     * （可选）获取签署页面链接
     * @return
     * @throws EsignDemoException
     */
    public static EsignHttpResponse signUrl() throws EsignDemoException {
        //signFlowId签署流程ID
        String signFlowId="";
        String apiaddr = "/v3/sign-flow/" + signFlowId + "/sign-url";
        String jsonParm = "{\n" +
                "  \"clientType\": \"ALL\",\n" +
                "  \"needLogin\": false,\n" +
                "  \"operator\": {\n" +
                "    \"psnAccount\": \"签署人手机号\"\n" +
                "  },\n" +
                "  \"urlType\": 2\n" +
                "}";
        //请求方法
        EsignRequestType requestType = EsignRequestType.POST;
        //生成请求签名鉴权方式的Header
        Map<String, String> header = EsignHttpHelper.signAndBuildSignAndJsonHeader(eSignAppId, eSignAppSecret, jsonParm, requestType.name(), apiaddr, true);
        //发起接口请求
        return EsignHttpHelper.doCommHttp(eSignHost, apiaddr, requestType, jsonParm, header, true);
    }
    /**
     * 下载已签署文件及附属材料
     * @return
     * @throws EsignDemoException
     */
    public static EsignHttpResponse fileDownloadUrl( ) throws EsignDemoException {
        //signFlowId签署流程ID
        String signFlowId="";
        String apiaddr = "/v3/sign-flow/"+ signFlowId +"/file-download-url";
        //请求参数body体,json格式。get或者delete请求时jsonString传空json:"{}"或者null
        String jsonParm=null;
        //请求方法
        EsignRequestType requestType= EsignRequestType.GET;
        //生成签名鉴权方式的的header
        Map<String, String> header = EsignHttpHelper.signAndBuildSignAndJsonHeader(eSignAppId,eSignAppSecret,jsonParm,requestType.name(),apiaddr,true);
        //发起接口请求
        return EsignHttpHelper.doCommHttp(eSignHost, apiaddr,requestType , jsonParm, header,true);
    }
}
